<?php
/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Controllers\Administrator;

use App\Exceptions\DefaultException;
use App\Http\Base\BaseController;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Services\PenerimaanmakananService;
use App\Http\Validators\PenerimaanmakananValidator;
use App\Http\Services\ApplicationparameterService;
use App\Http\Services\ItemService;
use App\Http\Services\LokasiitemService;
use App\Http\Services\WorkflowService;
use App\Http\Services\ItempenerimaanmakananService;
// use App\Http\Services\UsersService;
use App\Http\Services\StokkapalService;
use App\Http\Services\VoyagesService;
use App\Http\Services\AccountService;
use App\Http\Services\ActivitylogService;

class PenerimaanmakananController extends BaseController
{
    protected $baseService;
    protected $validator;
    // private $kapal;
    private $lokasiitem;
    private $account;
    private $itempenerimaanmakanan;
    private $voyage;
    private $item;
    private $stokkapal;
    private $appParam;
    private $workflow;
    private $activityLog;
    
    // private $users;

    /**
     * Penerimaanmakanan constructor.
     */
    public function __construct()
    {
        parent::__construct();
        $this->baseService = new PenerimaanmakananService();
        $this->validator = new PenerimaanmakananValidator();
        $this->appParam = new ApplicationparameterService();
        $this->item = new ItemService();
        $this->workflow = new WorkflowService();
        $this->lokasiitem = new LokasiitemService();
        $this->account = new AccountService();
        $this->itempenerimaanmakanan = new ItempenerimaanmakananService();
        $this->voyage = new VoyagesService();
        // $this->users = new UsersService();
        $this->stokkapal = new StokkapalService();
        $this->activityLog= new ActivitylogService();

    }


    /**
     * @param Request $request
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function store(Request $request)
    {
        $input = $request->all();
        $this->validator->beforeInsert($input);
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {            
            $auth = json_decode($request->session()->get('auth'));

            // $input["refId"] = $input["mrNumber"] = $this->baseService->getLastestID("PELNI/" . $input["tipeTransaksi"] . " " . date("y") . " " . $input["kodeKapal"]);   
            $input["refId"] = $input["mrNumber"] = $this->baseService->getLastestID( $input["tipeTransaksi"] . date("y") . $auth->orgId);
            
            $ID = $this->baseService->store($input);
            $this->itempenerimaanmakanan->store($input);

            $this->workflow->store($input);

            $input["date"] = date("Y-m-d H:i:s");
            $input["username"] = $auth->username;
            $input["activity"] = "CREATE";
            $input["deskripsi"] = $auth->name . " just <b>created</b> new Misc. Receipt <a href=\"" . url("administrator/penerimaanmakanan/" . $ID ) . "\">" . $input["refId"] . "</a>";
            $this->activityLog->store($input);

            DB::commit();
            $this->sync(); //ini untuk sync ke log sync, data tetap terkirim ke HO
            return redirect()->to("administrator/penerimaanmakanan")->with("successMessages", "Dataa sudah berhasil disimpan dengan No #" . $input["refId"]);
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @param Request $request
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function paging(Request $request)
    {
        $this->data["header"] = [
            "id" => "ID"
            , "namaLokasi" => "Asal"
            , "destinationAccount" => "Account"
            , "date" => "Tanggal Penerimaan"
        ];
        $this->data["criteria"] = [
            "id" => "ID"
            , "namaLokasi" => "Asal"
            , "destinationAccount" => "Account"
            , "date" => "Tanggal Penerimaan"
        ];
        $this->data["ordering"] = [
            "mrNumber:asc" => "No Transaksi &uarr;"
            , "mrNumber:desc" => "No Transaksi &darr;"
            , "date:asc" => "Tgl Transaksi &uarr;"
            , "date:desc" => "Tgl Transaksi &darr;"
            , "voyageKode:asc" => "Voyage &uarr;"
            , "voyageKode:desc" => "Voyage &darr;"
        ];
        $input = $request->all();
        $this->data["voyages"] = $this->voyage->getVoyages($request);
        $this->data["penerimaanmakanans"] = $this->baseService->paging($request);
        return view("modules.penerimaanmakanan.penerimaanmakanan_index", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function edit($id)
    {
        $this->data["penerimaanmakanan"] = $this->baseService->show($id);
        $this->data["criteria"] = ["id" => "ID" ,"namaItem" => "Nama Item", "deskripsi" => "Deskripsi"];
        $this->data["listItems"] = $this->itempenerimaanmakanan->showBasedOnPenerimaanMakanan($request, $id);
        return view("modules.penerimaanmakanan.penerimaanmakanan_edit", $this->data);
    }


    /**
     * @param Request $request
     * @param $id
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function update(Request $request, $id)
    {
        $this->validator->beforeUpdate($request->all(), $id);
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $this->baseService->update($id, $request->all());
            DB::commit();
            $this->sync();
            return redirect()->to("administrator/penerimaanmakanan")->with("successMessages", "Data has been updated");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function create(Request $request) {
        $auth = json_decode($request->session()->get("auth"));
        if(isset($auth->sysParams->WIP)) {
            $this->data["lokasiitems"] = $this->lokasiitem->index($request);
            $this->data["accounts"] = $this->account->AccountMakanan();

            $this->data["criteria"] = [
                "namaItem"      => "Kode Item",
                "deskripsi"     => "Deskripsi" /* ,
                "partnumber"    => "Part Number" */
            ];

            return view("modules.penerimaanmakanan.penerimaanmakanan_create", $this->data);
        } else {
            return redirect()->back()->with("errMessage", "System Paramter: WIP belum di set. Please check this with your Administrator/Nahkoda.");
        }
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function show(Request $request, $id)
    { 
        try {
            $this->data["penerimaanmakanan"] = $this->baseService->show($id);
            if($this->data["penerimaanmakanan"]) {                
                $this->data["listItems"] = $this->itempenerimaanmakanan->showBasedOnPenerimaanMakanan($request, $this->data["penerimaanmakanan"]);
                return view("modules.penerimaanmakanan.penerimaanmakanan_show", $this->data);
            } else {
                return redirect()->back()->with("errMessage", "No data found. Please check this with your Administrator/Nahkoda.");
            }
        } catch (\Exception $e) {
            return redirect()->back()->with("errMessage", "No data found. Please check this with your Administrator/Nahkoda.");
        }
    }

    /**
     *  index function that get all data from database by default
     * @param $ids
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function destroy($ids)
    {
        $this->baseService->delete($ids);
        return redirect()->back()->with("successMessages", "Data has been deleted");
    }


    public function approval(Request $request, $id)
    {       
        $this->data["penerimaanmakanan"] = $this->baseService->show($id);
        $this->data["listItems"] = $this->itempenerimaanmakanan->showBasedOnPenerimaanMakanan($request, $this->data["penerimaanmakanan"]);
        $this->data["isApproval"] = true;
        return view("modules.penerimaanmakanan.penerimaanmakanan_show", $this->data);
    }

    public function saveApproval(Request $request)
    {       
        $auth = json_decode($request->session()->get('auth'));
        $input = $request->all();
        $input["refId"] = $input["mrNumber"];
        $this->validator->beforeApprove($input);
        if ($this->validator->hasError()) {
            return $this->validator->validateView();
        }

        $transaction = $this->baseService->showByTransactionNo($input["refId"]);
        if($transaction->status > 0) {
            return redirect()->back()->with("errMessage", "Status transaksi #" . $input["refId"] . " sudah tidak open lagi!");
        } else {                
            DB::beginTransaction();
            try {
                $this->baseService->approve($input);
                $this->workflow->approve($input);
                $input["username"] = $auth->username;

                if($input["status"] == 1) {
                    $staging["header"] = $transaction; // $this->baseService->showByTransactionNo($input["mrNumber"]);
                    $staging["footer"] = $input["items"] = $this->itempenerimaanmakanan->showBasedOnPenerimaanMakanan($request, $staging["header"]);
                    
                    $input["date"] = $staging["header"]->date;  
                    $data = $this->baseService->getPrepareUpdateStock($input);
                    $this->stokkapal->updateStock($data);
                    
                    $staging["auth"] = $auth;
                    $this->baseService->saveStaging($staging);
                }
                
                        
                $input["activity"] = "APPROVAL";
                $input["namaTransaksi"] = "Workflow";
                $input["deskripsi"] = $auth->name . " just <b>approved</b> transaction Penerimaan Makanan <b>#" . $input["refId"] . "</b>";
                $this->activityLog->store($input);
                
                DB::commit();
                $this->sync();
                return redirect()->to("administrator/workflow")->with("successMessages", "Data dengan No #" . $input["refId"] . " sudah berhasil disimpan");
            } catch (\Exception $e) {
                DB::rollBack();
                throw new DefaultException($e->getMessage());
            }
        }
    }


    public function generateLotNumber() {
        $lotNumber = $this->appParam->generateLotNumber();
        echo json_encode($lotNumber);
    }

    public function search(Request $request) {
        $data = $this->item->pagingModalMakanan($request);
        echo json_encode($data); 
    } 

}
